// LICENSE : MIT
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = function (_ref) {
  var _visitor;

  var t = _ref.types;
  var template = _ref.template;

  var injectAssert = function injectAssert(path, leadingComments, options) {
    var converterOptions = useGenerator(options);
    var comment = leadingComments[leadingComments.length - 1];
    if (comment.type === 'CommentBlock') {
      var asserts = _jsdocToAssert.CommentConverter.toAsserts(comment, converterOptions);
      // no have assert, ignore this
      if (asserts.length === 0) {
        return;
      }
      var functionDeclarationString = asserts.filter(function (line) {
        return line != null;
      }).map(function (line) {
        return line.trim();
      }).join("\n");
      var buildAssert = template(functionDeclarationString)();
      var bodyPath = path.get("body");
      if (bodyPath && bodyPath.node && bodyPath.node["body"]) {
        bodyPath.unshiftContainer("body", buildAssert);
      }
    }
  };
  return {
    visitor: (_visitor = {}, _defineProperty(_visitor, "ArrowFunctionExpression|VariableDeclaration", function ArrowFunctionExpressionVariableDeclaration(path) {
      if (maybeSkip(path)) {
        return;
      }
      var node = path.node;

      if (node.declarations) {
        var declaration = path.get('declarations')[0];
        if (declaration.isVariableDeclaration()) {
          return;
        }
        var init = declaration.get("init");
        if (!init) {
          return;
        }
        injectAssert(init, node.leadingComments, this.opts);
      }
    }), _defineProperty(_visitor, "ExportNamedDeclaration", function ExportNamedDeclaration(path) {
      if (maybeSkip(path)) {
        return;
      }
      var node = path.node;

      if (node.declaration) {
        var declaration = path.get("declaration");
        if (declaration.isVariableDeclaration()) {
          return;
        }
        injectAssert(declaration, node.leadingComments, this.opts);
      }
    }), _defineProperty(_visitor, "ObjectMethod|ClassMethod|FunctionDeclaration", function ObjectMethodClassMethodFunctionDeclaration(path) {
      if (maybeSkip(path)) {
        return;
      }
      var node = path.node;

      injectAssert(path, node.leadingComments, this.opts);
    }), _visitor)
  };
};

var _jsdocToAssert = require("jsdoc-to-assert");

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SimpleGenerator = function () {
  function SimpleGenerator() {
    _classCallCheck(this, SimpleGenerator);
  }

  _createClass(SimpleGenerator, [{
    key: "assert",
    value: function assert(expression) {
      return "console.assert(" + expression + ");";
    }
  }]);

  return SimpleGenerator;
}();

var NodeAssertGenerator = function () {
  function NodeAssertGenerator() {
    _classCallCheck(this, NodeAssertGenerator);
  }

  _createClass(NodeAssertGenerator, [{
    key: "assert",
    value: function assert(expression) {
      return "assert(" + expression + ");";
    }
  }]);

  return NodeAssertGenerator;
}();

function maybeSkip(path) {
  var node = path.node;

  if (node.leadingComments != null && node.leadingComments.length > 0) {
    return false;
  }
  return true;
}


function useGenerator() {
  var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  if (options.simple) {
    return {
      Generator: SimpleGenerator
    };
  }
  if (options.useNodeAssert) {
    return {
      Generator: NodeAssertGenerator
    };
  }
  return {};
}
module.exports = exports['default'];
//# sourceMappingURL=index.js.map